% Genome Browser Tutorials

# Introduction to the UCSC Genome Browser

This page attempts to introduce you to the basics of using the UCSC Genome Browser including:

- Basic Navigation
- Basic Table Browser Query
- Basic BLAT Query

## Sections

Use the sections below to learn about the UCSC Genome Browser interface.

<div class="row" style="padding-top: 15px">
<div class="col-md-4">
<div class="panel panel-default" style="padding-bottom: 10px">
<h3 class="panel-title" style="width: -webkit-fill-available;"
>Genome Browser Interface</h3>

Annotated screenshot of the Genome Browser interface. Explains what all the buttons do

<p style="text-align: end">
<button>[View](#annot-screenshot)</button>
</p>
</div>
</div>
<div class="col-md-4">
<div class="panel panel-default" style="padding-bottom: 10px">
<h3 class="panel-title" style="width: -webkit-fill-available;"
>Guided Workthrough</h3>

Explains the basis of using/navigating the Genome Browser interface. 
Also explains a very basic Table Browser query and BLAT query.

<p style="text-align: end">
<button>[View](#guided-work)</button>
</p>
</div>
</div>
<div class="col-md-4" style="padding-top: 15px">
<div class="panel panel-default" style="padding-bottom: 10px">
<h3 class="panel-title" style="width: -webkit-fill-available;"
>Interactive Tutorial</h4>

Steps you through the basic functionality in the Genome Browser itself.  


<p style="text-align: end">
<button>[View](../cgi-bin/hgTracks?#showTutorial)</button>
</p>
</div>
</div>
</div>

## Annotated Screenshot

![Annotated image of the UCSC Genome Browser Interface](../images/annot-screenshot-sarCov2.jpg)

| Item | Explanation |
|------|-------------|
| Menu | Find BLAH   |

(Wee need something below the table otherwise later markdown isn't properly interpreted)

## Guided Workthorugh

This walkthrough will take you through the basic Genome Browser functionality.

By the end of the workthrough you should be able to do these three things:

1. Naviagte the Genome Browser Interface
2. Perform a basic Table Browser query
3. Perform a simple BLAT query

### Genome Browser Basics

In this guided walkthrough, we go from selecting our genome (hg38 in this
case), to going to our gene of interest (BLAH), to turning off and on some of
our favorite tracks, before finally BLAH. 

#### Step 1: Choose your genome

<!--
We are going to use bootstrap columns to put the image/text side by side
Alternate the images left/right between different sections, mostly for aesthetics
--->

<div class="row">
<div class="col-md-6">

<img src="../images/GenomeSelect.jpg" alt="Genome selection" style="max-width:100%;">

</div>
<div class="col-md-6">

Go to BLAH, select your genome from the diagram or search for in the search box at the top left of the screen.

For this walkthrough, we will select "Human" and stick with the default GRCh38/hg38 assembly.
</div>
</div>

<!-- note to self, something seems off with the image handling here? like too wide and not auto-fitting to the col -->

#### Step 2: Navigate to your gene of interest

<div class="row">
<div class="col-md-6">

After selecting a genome, enter a gene name into the search box. In our case,
we will enter "HUNK", a gene for BLAH, into the search box. 

After typing in the name, select the gene name "HUNK" from the list that
appears below the search box. You will be taken directly to that gene location. 
</div>
<div class="col-md-6">

<img src="../images/GeneSearch.jpg" alt="Genome selection" style="max-width:100%;">

</div>
</div>

#### Step 3: Configure the Genome Browser tracks

<div class="row">
<div class="col-md-6">

The horizontal lines of genomic data in the UCSC Genome Browser are known as **tracks**. they may BLAH, BLAH, and BLAH

</div>
<div class="col-md-6">

<!--
<img> here
-->

</div>
</div>

### Simple Table Browser Query

#### Step 1:

BLAH

#### Step 2:

BLAH

#### Step 3:

BLAH

### Simple BLAT Query

#### Step 1:

BLAH

#### Step 2:

BLAH

#### Step 3:

BLAH
